#pragma once

#include "CoreMinimal.h"
#include "ChargeableInteractionDefinition.h"
#include "Templates/SubclassOf.h"
#include "UseContaminationAntidoteInteraction.generated.h"

class UFloatValueStrategy;
class UStatusEffect;
class ASurvivor;

UCLASS(Blueprintable, Abstract, EditInlineNew, meta=(BlueprintSpawnableComponent))
class DBDSURVIVORCOLLECTABLES_API UUseContaminationAntidoteInteraction : public UChargeableInteractionDefinition
{
	GENERATED_BODY()

protected:
	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	FName _contaminationAntidoteItemId;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, Instanced)
	UFloatValueStrategy* _killerInstinctDurationStrategy;

private:
	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	TSubclassOf<UStatusEffect> _killerInstinctClass;

protected:
	UFUNCTION(BlueprintPure)
	ASurvivor* GetInteractionTarget() const;

public:
	UUseContaminationAntidoteInteraction();
};

FORCEINLINE uint32 GetTypeHash(const UUseContaminationAntidoteInteraction) { return 0; }
